package RPM::Source::Convert::Plugins::SRPMReset;
use strict;
use warnings;
#use Carp;

use RPM::Source::Transformation::Factory;
our @ISA=qw/RPM::Source::Transformation::Factory/;

push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

our $VERSION=0.001;

our $verbose=0;

sub register_messages {
    my ($self,$extopt)=@_;
    ### TODO: use some fixed keys hash here
    RPM::Source::Transformation::Component::add_opt($extopt, {
	-srpm_reset_speclist_after_reinit => 0,
	-srpm_reset_macros_after_reinit => 0,
	-srpm_reset_sources_after_reinit => 0,
    });
}

sub transformations {
    return 
	RPM::Source::Transformation::OptHandlerWrapper->new(
	    -priority => PRIORITY_SRPM_RESET,
	    -name => 'reinitialize srpm after foreign package macro expansion',
	    -opt_handler_sub=>\&opt_handler_macro_SRPM_RESET);
}

sub opt_handler_macro_SRPM_RESET {
    my ($self,$spec,undef,$opt,$resourceobj)=@_;
    #my $macros=$spec->macros();
    if ($opt->{-srpm_reset_speclist_after_reinit}) {
	$spec->_reset_speclist();
    }
    if ($opt->{-srpm_reset_macros_after_reinit}) {
	$spec->_reset_macros();
    }
    if ($opt->{-srpm_reset_macros_after_reinit} or $opt->{-srpm_reset_sources_after_reinit}) {
	$spec->_reset_sources();
    }
    return RPM::Source::TransformContainer::TRANSFORMATION_OK;
}


1;
